//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1  20
#property indicator_level2  80
#property indicator_level3  50
#property indicator_color1  DodgerBlue
#property indicator_color2  Red

//
//
//
//
//

extern string  TimeFrame   = "Current time frame";
extern int     StochasticK  = 100;
extern int     Slowing      = 1;
extern string  FirstSymbol  = "";
extern string  SecondSymbol = "GBPUSD";
extern bool    Interpolate  = true;

double buffer1[];
double buffer2[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   if (FirstSymbol == "" ) FirstSymbol = Symbol();
      SetIndexBuffer(0,buffer1);
      SetIndexBuffer(1,buffer2);

      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,y,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0] = limit; return(0); }
           if (FirstSymbol  != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(FirstSymbol ,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
           if (SecondSymbol != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(SecondSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      y = iBarShift(FirstSymbol ,timeFrame,Time[i]); buffer1[i] = iStochastic(FirstSymbol ,timeFrame,StochasticK,1,Slowing,0,0,0,y);
      y = iBarShift(SecondSymbol,timeFrame,Time[i]); buffer2[i] = iStochastic(SecondSymbol,timeFrame,StochasticK,1,Slowing,0,0,0,y);
      
      if (timeFrame <= Period() || !Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

      //
      //
      //
      //
      //
      
      datetime time = iTime(NULL,timeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
         for(int k = 1; k < n; k++)
         {
            buffer1[i+k] = buffer1[i] +(buffer1[i+n]-buffer1[i])*k/n;
            buffer2[i+k] = buffer2[i] +(buffer2[i+n]-buffer2[i])*k/n;
         }               
   }
   IndicatorShortName(timeFrameToString(timeFrame)+" Stochastic ("+StochasticK+","+Slowing+")   "+FirstSymbol+","+SecondSymbol+" - Diff: "+DoubleToStr(MathAbs(buffer1[0]-buffer2[0]),0)+"%    ");
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

